﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfClient.DataAccess;
using WpfClient.Model;

namespace WpfClient
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public AuthorsFormModel Model { get; set; }

        AuthorsGateway gateway = new AuthorsGateway();

        public MainWindow() {
            Model = new AuthorsFormModel {
                Authors = new ObservableCollection<AuthorModel>(gateway.ListAuthors())
            };
            InitializeComponent();
        }

        private void Save_OnClick(object sender, RoutedEventArgs e) {
            var author = Model.SelectedAuthor;
            int id;
            if (author.Id.HasValue) {
                gateway.UpdateAuthor(author.Id.Value, author.Name, author.BirthDate.Value);
                id = author.Id.Value;
            } else {
                id = gateway.AddNewAuthorViaSP(author.Name, author.BirthDate.Value);
            }
            Refresh();
            Model.SelectedAuthor = Model.Authors.FirstOrDefault(a => a.Id == id);
        }

        private void Create_OnClick(object sender, RoutedEventArgs e) {
            AuthorModel newAuthor = new AuthorModel();
            Model.Authors.Add(newAuthor);
            Model.SelectedAuthor = newAuthor;
        }

        private void Delete_OnClick(object sender, RoutedEventArgs e) {
            gateway.removeAuthor(Model.SelectedAuthor.Id.Value);
            Refresh();
        }

        private void Refresh() {
            Model.Authors = new ObservableCollection<AuthorModel>(gateway.ListAuthors());
        }
    }
}
